#ifndef PLATFORM_H
#define PLATFORM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "r_cg_macrodriver.h"
#include "r_cg_userdefine.h"
#if defined(__CCRL__) && !defined(_STDINT_H)
#define _STDINT_H
#endif
////#include "FreeRTOS.h"
////#include "task.h"
////#include "semphr.h"
////#include "queue.h"
////#include "croutine.h"
////#include "timers.h"
////#include "event_groups.h"

#if defined(__CCRL__) && (!defined(__STDC_VERSION__) || (__STDC_VERSION__ < 199901L))
#define bool    _Bool
#define true    1
#define false   0
#define __bool_true_false_are_defined   1
#else
#include <stdbool.h>
#endif
#include <stdio.h>
#include <stddef.h>
#include <string.h>

#if defined(__GNUC__)
#define BRK()     asm("brk")
#endif

#define di()      DI()
#define ei()      EI()
#define halt()    HALT()
#define nop()     NOP()
#define stop()    STOP()
#define brk()     BRK()

#define INTERNAL_NOT_USED(p)        ((void)(p))

#if defined(__CCRL__)

#define R_CG_DEFAULT_ISR_UNUSED(name)\
    static void __near name##_UNUSED(void);\
    void _##name##_UNUSED(void){name##_UNUSED();}

#define R_CG_REDEFINE_ISR(name)\
    static void __near name(void);

#elif defined(__GNUC__)

#define R_CG_DEFAULT_ISR_UNUSED(name)\
    void name##_UNUSED(void) __attribute__ ((unused));

#define R_CG_REDEFINE_ISR(name)\
    void name(void) __attribute__ ((interrupt));

#endif

#if defined(RENESAS_SIMULATOR_DEBUGGING)
#include "RenesasSimDebug/sim_debug_mode_hook.h"
#endif

#ifdef __cplusplus
}
#endif

#endif /* PLATFORM_H */
